难度:中等
给定一个字符串 s ,请你找出其中不含有重复字符的 最长子串 的长度。
示例 1:
输入: s = "abcabcbb"
输出: 3
解释: 因为无重复字符的最长子串是 "abc",所以其长度为 3。示例 2:
输入: s = "bbbbb"
输出: 1
解释: 因为无重复字符的最长子串是 "b",所以其长度为 1。示例 3:
输入: s = "pwwkew"
输出: 3
解释: 因为无重复字符的最长子串是 "wke",所以其长度为 3。
请注意,你的答案必须是 子串 的长度,"pwke" 是一个子序列,不是子串。示例 4:
输入: s = ""
输出: 0提示:
0 <= s.length <= 5 * 104s 由英文字母、数字、符号和空格组成思路:通过数组下标方式遍历字符串并逐个比较,需要考虑非常多种可能的输入。(多次修改后最终用经典暴力求解法得出(也许)准确的答案)
class Solution {
public:
int lengthOfLongestSubstring(string s) {
int count = 1, max = 0, n = 0;
for (int i = 1; i < s.length(); i++) {
count = 1;
int j;
for (j = n; j < i; j++) {
if (s[j] != s[i]) {
count++;
}
else {
max = max > count ? max : count;
count = 1;
n = j + 1;
break;
}
}
max = max > count ? max : count;
if (j == n) {
max--;
}
}
if(s.length() == 1) {
max = 1;
}
return max;
}
};在官方题解中提到一种新的方法:滑动窗口。
我们先用一个例子考虑如何在较优的时间复杂度内通过本题。 我们不妨以示例一中的字符串 abcabcbb 为例,找出从每一个字符开始的,不包含重复字符的最长子串,那么其中最长的那个字符串即为答案。对于示例一中的字符串,我们列举出这些结果,其中括号中表示选中的字符以及最长的字符串: 以 (a)bcabcbb 开始的最长字符串为 (abc)abcbb; 以 a(b)cabcbb 开始的最长字符串为 a(bca)bcbb; 以 ab©abcbb 开始的最长字符串为 ab(cab)cbb; 以 abc(a)bcbb 开始的最长字符串为 abc(abc)bb; 以 abca(b)cbb 开始的最长字符串为 abca(bc)bb; 以 abcab©bb 开始的最长字符串为 abcab(cb)b; 以 abcabc(b)b 开始的最长字符串为 abcabc(b)b; 以 abcabcb(b) 开始的最长字符串为 abcabcb(b)。 发现了什么?如果我们依次递增地枚举子串的起始位置,那么子串的结束位置也是递增的!这里的原因在于,假设我们选择字符串中的第 k 个字符作为起始位置,并且得到了不包含重复字符的最长子串的结束位置为 r_k。那么当我们选择第 k+1 个字符作为起始位置时,首先从 k+1 到 r_k 的字符显然是不重复的,并且由于少了原本的第 k 个字符,我们可以尝试继续增大 r_k,直到右侧出现了重复字符为止。 这样一来,我们就可以使用「滑动窗口」来解决这个问题了:
作者:LeetCode-Solution
因为涉及到哈希表,这里练习一下c++中哈希表的使用,用滑动窗口方法重写了一遍代码:
class Solution {
public:
int lengthOfLongestSubstring(string s) {
unordered_set<char> osc;
int len = s.size();
int h = -1, Max = 0;
for(int i = 0; i < len; i++) {
if(i != 0) {
//erase函数删除表中指定元素
osc.erase(s[i-1]);
}
while(h + 1 < len && !osc.count(s[h+1])) {
//count函数统计字哈希表中某个元素出现的次数
//insert函数在表中插入元素
osc.insert(s[h+1]);
h++;
}
Max = max(Max, h - i + 1);
}
return Max;
}
};讲道理,滑动窗口法跟我的死板破解法原理也差不了太多,但是这个方法一分析就是要丝滑好多,终究还是我小题大做方向错了。
惯例,用Java复习一遍:
(发现右索引标识为-1必要性貌似不大,这里试验了一下,貌似代码更简洁了,还是建议按照思路从-1开始,毕竟,咱是小白咱不懂咱也不敢多说。)
class Solution {
public int lengthOfLongestSubstring(String s) {
Set<Character> hash = new HashSet<Character>();
int len = s.length();
int h = 0, max = 0;
for(int i = 0; i < len; i++) {
if(i != 0) {
hash.remove(s.charAt(i - 1));
}
while(h < len && !hash.contains(s.charAt(h))) {
hash.add(s.charAt(h));
h++;
}
max = max > (h - i) ? max : (h - i);
}
return max;
}
}